#!/usr/local/bin/perl -wT

use CGI;
use CGI::Carp 'fatalsToBrowser';

# Usage: (for testing from outside of the web browser)
# cgi-extract-contig m=<model> org=<org_3letter_abbrev> idx=-1 \
#                    contig="><contig_name>" from=<from> to=<to>


my $base = "/var/tmp/bacteria";
my $tmp = "$base/$$";

my $MENTERIC_DIR = "/usr/local/menteric";
 
$ENV{'PATH'} = "$MENTERIC_DIR/bin:/usr/local/bin:/usr/bin";
$ENV{'USER'} = 'menteric'; # dotplot puts this in a DSC comment.
$ENV{'HOME'} = '/usr/local/'; # acrobat distiller wants this.

umask(0000);
$|=1;

sub plumber { &cleanup ; exit(0); }
$SIG{'PIPE'} = \&plumber;
$SIG{'INT'} = \&plumber;
$SIG{'TERM'} = \&plumber;
$SIG{'HUP'} = \&plumber;

mkdir("$base",0775);
mkdir($tmp,0777) or die "mkdir $tmp: $!";
chdir($tmp) or die "chdir $tmp: $!";

sub END {
  plumber($tmp);
}

sub rm_all_files {
    opendir(DIR,".") or die "opendir: $!";
    @files = grep { -f $_ } readdir(DIR);
    @files = map {m!^([^/]+)$! ; $1} @files;  # untaint
    unlink @files or warn "unlink: $!";
    closedir DIR;
}   

sub cleanup {

  if (defined($tmp)) {
    chdir($tmp) or die "chdir $tmp: $!";
    &rm_all_files;
    chdir($base) || die ;
    rmdir($tmp);
  }
}

sub system_with_stdout {  # file command args_to_command

  my $file = shift;

  local(*save);
  open(*save, ">& STDOUT") or die "save stdout: $!";
  open(STDOUT, "> $file\0") or die "open: $file: $!";
  !system { $_[0] } @_ or die "system: $_[0]: $?";
  open(STDOUT, ">& save") or die "restore stdout: $!";
} 


my $q = new CGI;
my $model = $q->param('m');
my $org =  $q->param('org');
my $contig = $q->param('contig');
my $idx = $q->param('idx'); 
my $from = $q->param('from'); 
my $to = $q->param('to');

if ($model=~/^(\w+)$/) { $model = $1; } else { die "Model system name is invalid."; }
if ($org=~/^([A-Z]+)$/) { $org = $1; } else { die "Organism name is invalid.";}
if ($contig=~/^(\S+)$/) { $contig = $1; } else { die "Contig name cannot include spaces."; }
if ($idx=~/^(\-?\d+)$/) { $idx = $1; } else { die "Index number must be numeric."; }
if ($from=~/^(\d+)$/) { $from = $1; } else { die "From value must be numeric."; }
if ($to=~/^(\d+)$/) { $to = $1; } else { die "To value must be numeric."; }
 
#select the proper set of data directories
my $der_datadir;
my $bas_datadir;
my $alias_file;
my @gsystems=("bacteria", "hoxd");

foreach $sys (@gsystems) {
   next if ($model ne $sys);
   if (!defined($der_datadir)) {
       open(F, "<$MENTERIC_DIR/data/$sys/derived/sequence.alias") or die;
       while (<F>) {
          next if /^#/ || /^\s*$/; chop;
          if (/^\S+\s+($org)\s*$/) {
             $der_datadir = "$MENTERIC_DIR/data/$sys/derived";
             $bas_datadir = "$MENTERIC_DIR/data/$sys/basic";
             $alias_file = "sequence.alias";
             last;
          }
      }
      close(F);
   }
   last;
}

chdir($tmp) or die; 
system_with_stdout "contig",
	"extract_contig", "$org", "$contig", "$idx",
		"-a", "$alias_file", 
		"-d", "$der_datadir",
		"-b", "$bas_datadir";

print $q->header(-type => 'text/html'), "\n", $q->start_html, "\n";
print $q->h2("Results of contig search"), "<br>\n";
print "\<b\>Organism code: $org\</b\>", $q->br, "\n";
print "\<b\>From: $from\</b\>", $q->br, "\n";  
print "<b>To: $to</b><br>&nbsp;<br><hr><br>\n";

open(F, "contig") or die;
$_ = <F>;   # Fasta header
print "<b><font size+=1>$_ </font></b><br>&nbsp;<br>\n";
print "<tt>\n";
while (<F>) { print or die; printf "<br>\n"; }
print "</tt>\n";

close(F) or die;

printf $q->end_html;


