#!/usr/local/bin/perl -wT

($#ARGV==0) || die "Usage: $0 <cons_file>\n";

my $consfile = shift;

open(CONS, "<$consfile\0") || die "Could not open file $consfile.";
$_ = <CONS>;
(/^#:plain:\n$/) || die "Not a cons format file.";
print $_;

$end_cluster = -1;
while (<CONS>) {
   next if (/^#/ || /^\s*$/); 
   
   (($from, $to) = /^(\d+)\s+(\d+)\s+/) ||
      die "Not a cons format file.";
   if ($from > $end_cluster) {
      if ($end_cluster>=0) {
         print "$begin_cluster $end_cluster\n";
      }
      $begin_cluster = $from;
   }
   $end_cluster = $to; 
}

if ($end_cluster>=0) {
    print "$begin_cluster $end_cluster\n";
}

close(CONS) || die "Could not close $consfile.";



