/* generate a "mirror" of the blastz output files, statically (before 
   execution time) */  

#include "psublast.h"
#include "align.h"

#define Usage "%s filename [-d datadir]"

int main(int argc, char *argv[]) 
{
    ALIGN *al; 
    char datadir[100], buf[150];

    if ((argc!=2) && (argc!=4)) fatalf(Usage, argv[0]); 
    if (argc==4) {
        if (strncmp(argv[2],"-d",2)) fatalf(Usage, argv[0]);
        strcpy(datadir, argv[3]);
    } else 
        strcpy(datadir, ".");
    
    sprintf(buf, "%s%s", datadir, argv[1]); 
    al = ali_open(buf);  
    while (ali_read(al, NULL)>0) {
       while (ali_crt_read(al, NULL)>0)
           ali_print_coords(al);
    }

    ali_close(al);
    return 0;
} 
