#!/bin/ksh -ue

alifile=${1:?}
gnlandfile=${2:?}
showgn=${3:?}
prlandfile=${4:?}
showpr=${5:?}
pblandfile=${6:?}
showpb=${7:?}
consfile=${8:?}
GSYSTEM=${9:?}
ALIASES=$(< ./alias)

. /usr/local/menteric/lib/${GSYSTEM}.set-globals

cat <<! > specs
load file "$alifile" alias $ALIASES;
!
(
if (( $showgn ))
then
cat <<! >> specs
landmarks from "$gnlandfile" underlayed color 0.1 0.3 1.0; 
!
fi
)
(
if (( $showpr ))
then
cat <<! >> specs
landmarks from "$prlandfile" underlayed color 0.4 0.2 1.0;
!
fi
)
(
if (( $showpb ))
then
cat <<! >> specs
landmarks from "$pblandfile" underlayed color 0.0 0.2 1.0;
!
fi
)

cat <<! >> specs
annotations from "$consfile" box mark style solid;

no description;
page orientation portrait;
page width 100;
page spacing 1;
textfont 7;
    
top 1 tickmark every 10 stripped;
text all banner font "Courier" 8  dotted pivot 1 trailer font "Bold" 8 started ended;
    
output postscript;
!
